---
title: Compiling from Rust to WebAssembly
slug: WebAssembly/Rust_to_wasm
tags:
  - Compiling
  - WebAssembly
  - rust
  - wasm
---
<div>{{WebAssemblySidebar}}</div>

<p class="summary">If you have some Rust code, you can compile it into <a href="/en-US/docs/WebAssembly">WebAssembly</a> (wasm). This tutorial takes you through all you need to know to compile a Rust project to wasm and use it in an existing web app.</p>

<h2 id="Rust_and_WebAssembly_use_cases">Rust and WebAssembly use cases</h2>

<p>There are two main use cases for Rust and WebAssembly:</p>

<ul>
 <li>Build an entire application — an entire web app based in Rust.</li>
 <li>Build a part of an application — using Rust in an existing JavaScript frontend.</li>
</ul>

<p>For now, the Rust team is focusing on the latter case, and so that's what we cover here. For the former case, check out projects like <a href="https://github.com/DenisKolodin/yew"><code>yew</code></a>.</p>

<p>In this tutorial, we build an npm package using <code>wasm-pack</code>, a tool for building npm packages in Rust. This package will contain only WebAssembly and JavaScript code, and so the users of the package won't need Rust installed. They may not even notice that it's written in Rust.</p>

<h2 id="Rust_Environment_Setup">Rust Environment Setup</h2>

<p>Let's go through all the required steps to get our environment set up.</p>

<h3 id="Install_Rust">Install Rust</h3>

<p>Install Rust by going to the <a href="https://www.rust-lang.org/install.html">Install Rust</a> page and following the instructions. This installs a tool called "rustup", which lets you manage multiple versions of Rust. By default, it installs the latest stable Rust release, which you can use for general Rust development. Rustup installs <code>rustc</code>, the Rust compiler, as well as <code>cargo</code>, Rust's package manager, <code>rust-std</code>, Rust's standard libraries, and some helpful docs — <code>rust-docs</code>.</p>

<div class="notecard note">
<p><strong>Note</strong>: Pay attention to the post-install note about needing cargo's <code>bin</code> directory in your system <code>PATH</code>. This is added automatically, but you must restart your terminal for it to take effect.</p>
</div>

<h3 id="wasm-pack">wasm-pack</h3>

<p>To build the package, we need an additional tool, <code>wasm-pack</code>. This helps compile the code to WebAssembly, as well as produce the right packaging for <code>npm</code>. To download and install it, enter the following command into your terminal:</p>

<pre class="brush: bash; no-line-numbers notranslate">$ cargo install wasm-pack</pre>

<h3 id="Install_Node.js_and_npm">Install Node.js and npm</h3>

<p>We are building an npm package in this tutorial, and so you need to have Node.js and npm installed.</p>

<p>To get Node.js and npm, go to the <a href="https://www.npmjs.com/get-npm">Get npm!</a> page and follow the instructions. When it comes to picking a version, choose any one you'd like; this tutorial isn't version-specific.</p>

<h2 id="Building_our_WebAssembly_npm_package">Building our WebAssembly npm package</h2>

<p>Enough setup; let's create a new package in Rust. Navigate to wherever you keep your personal projects, and type this:</p>

<pre class="brush: bash; no-line-numbers notranslate">$ cargo new --lib hello-wasm
     Created library `hello-wasm` project</pre>

<p>This creates a new library in a subdirectory named <code>hello-wasm</code> with everything you need to get going:</p>

<pre class="brush: none no-line-numbers notranslate">+-- Cargo.toml
+-- src
    +-- lib.rs</pre>

<p>First, we have <code>Cargo.toml</code>; this is the file that we use to configure our build. If you've used <code>Gemfile</code> from Bundler or <code>package.json</code> from npm, this is likely to be familiar; Cargo works in a similar manner to both of them.</p>

<p>Next, Cargo has generated some Rust code for us in <code>src/lib.rs</code>:</p>

<pre class="brush: rust; notranslate">#[cfg(test)]
mod tests {
    #[test]
    fn it_works() {
        assert_eq!(2 + 2, 4);
    }
}</pre>

<p>We won't use this test code at all, so go ahead and delete it.</p>

<h3 id="Lets_write_some_Rust">Let's write some Rust</h3>

<p>Let's put this code into <code>src/lib.rs</code> instead:</p>

<pre class="brush: rust notranslate">use wasm_bindgen::prelude::*;

#[wasm_bindgen]
extern {
    pub fn alert(s: &amp;str);
}

#[wasm_bindgen]
pub fn greet(name: &amp;str) {
    alert(&amp;format!("Hello, {}!", name));
}</pre>

<p>This is the contents of our Rust project. It has three main parts; let's talk about each of them in turn. We give a high-level explanation here, and gloss over some details; to learn more about Rust, please check the free online book <a href="https://doc.rust-lang.org/book/">The Rust Programming Language</a>.</p>

<h4 id="Using_wasm-bindgen_to_communicate_between_Rust_and_JavaScript">Using <code>wasm-bindgen</code> to communicate between Rust and JavaScript</h4>

<p>The first part looks like this:</p>

<pre class="brush: rust notranslate">use wasm_bindgen::prelude::*;</pre>

<p>Libraries are called "crates" in Rust.</p>

<p>Get it? <em>Cargo</em> ships <em>crates</em>.</p>

<p>The first line contains a <code>use</code> command, which imports code from a library into your code. In this case, we're importing everything in the <code>wasm_bindgen::prelude</code> module. We use these features in the next section.</p>

<p>Before we move on to the next section, we should talk a bit more about <code>wasm-bindgen</code>.</p>

<p><code>wasm-pack</code> uses <code>wasm-bindgen</code>, another tool, to provide a bridge between the types of JavaScript and Rust. It allows JavaScript to call a Rust API with a string, or a Rust function to catch a JavaScript exception.</p>

<p>We use <code>wasm-bindgen</code>'s functionality in our package. In fact, that's the next section.</p>

<h4 id="Calling_external_functions_in_JavaScript_from_Rust">Calling external functions in JavaScript from Rust</h4>

<p>The next part looks like this:</p>

<pre class="brush: rust; notranslate">#[wasm_bindgen]
extern {
    pub fn alert(s: &amp;str);
}</pre>

<p>The bit inside the <code>#[ ]</code> is called an "attribute", and it modifies the next statement somehow. In this case, that statement is an <code>extern</code>, which tells Rust that we want to call some externally defined functions. The attribute says "wasm-bindgen knows how to find these functions".</p>

<p>The third line is a function signature, written in Rust. It says "the <code>alert</code> function takes one argument, a string named <code>s</code>."</p>

<p>As you might suspect, this is <a href="/en-US/docs/Web/API/Window/alert">the <code>alert</code> function provided by JavaScript</a>. We call this function in the next section.</p>

<p>Whenever you want to call JavaScript functions, you can add them to this file, and <code>wasm-bindgen</code> takes care of setting everything up for you. Not everything is supported yet, but we're working on it. Please <a href="https://github.com/rustwasm/wasm-bindgen/issues/new">file bugs</a> if something is missing.</p>

<h4 id="Producing_Rust_functions_that_JavaScript_can_call">Producing Rust functions that JavaScript can call</h4>

<p>The final part is this one:</p>

<pre class="brush: rust notranslate">#[wasm_bindgen]
pub fn greet(name: &amp;str) {
    alert(&amp;format!("Hello, {}!", name));
}</pre>

<p>Once again, we see the <code>#[wasm_bindgen]</code> attribute. In this case, it's not modifying an <code>extern</code> block, but a <code>fn</code>; this means that we want this Rust function to be able to be called by JavaScript. It's the opposite of <code>extern</code>: these aren't the functions we need, but rather the functions we're giving out to the world.</p>

<p>This function is named <code>greet</code>, and takes one argument, a string (written <code>&amp;str</code>), <code>name</code>. It then calls the <code>alert</code> function we asked for in the <code>extern</code> block above. It passes a call to the <code>format!</code> macro, which lets us concatenate strings.</p>

<p>The <code>format!</code> macro takes two arguments in this case, a format string, and a variable to put in it. The format string is the <code>"Hello, {}!"</code> bit. It contains <code>{}</code>s, where variables will be interpolated. The variable we're passing is <code>name</code>, the argument to the function, so if we call <code>greet("Steve")</code> we should see <code>"Hello, Steve!".</code></p>

<p>This is passed to <code>alert()</code>, so when we call this function we will see an alert box with "Hello, Steve!" in it.</p>

<p>Now that our library is written, let's build it.</p>

<h3 id="Compiling_our_code_to_WebAssembly">Compiling our code to WebAssembly</h3>

<p>To compile our code correctly, we first need to configure it with <code>Cargo.toml</code>. Open this file, and change its contents to look like this:</p>

<pre class="brush: toml notranslate">[package]
name = "hello-wasm"
version = "0.1.0"
authors = ["Your Name &lt;you@example.com&gt;"]
description = "A sample project with wasm-pack"
license = "MIT/Apache-2.0"
repository = "https://github.com/yourgithubusername/hello-wasm"
edition = "2018"

[lib]
crate-type = ["cdylib"]

[dependencies]
wasm-bindgen = "0.2"</pre>

<p>Fill in your own repository and use the same info that <code>git</code> uses for the <code>authors</code> field.</p>

<p>The big part to add is the <code>[package]</code>. The <code>[lib]</code> part tells Rust to build a <code>cdylib</code> version of our package; we won't get into what that means in this tutorial. For more, consult the <a href="https://doc.rust-lang.org/cargo/guide/">Cargo</a> and <a href="https://doc.rust-lang.org/reference/linkage.html">Rust Linkage</a> documentation.</p>

<p>The last section is the <code>[dependencies]</code> section. Here's where we tell Cargo what version of <code>wasm-bindgen</code> we want to depend on; in this case, that's any <code>0.2.z</code> version (but not <code>0.3.0</code> or above).</p>

<h3 id="Building_the_package">Building the package</h3>

<p>Now that we've got everything set up, let's build the package. Type this into your terminal:</p>

<pre class="brush: bash no-line-numbers notranslate">$ wasm-pack build</pre>

<p>This does a number of things (and they take a lot of time, especially the first time you run <code>wasm-pack</code>). To learn about them in detail, check out <a href="https://hacks.mozilla.org/2018/04/hello-wasm-pack/">this blog post on Mozilla Hacks</a>. In short, <code>wasm-pack build</code>:</p>

<ol>
 <li>Compiles your Rust code to WebAssembly.</li>
 <li>Runs <code>wasm-bindgen</code> on that WebAssembly, generating a JavaScript file that wraps up that WebAssembly file into a module npm can understand.</li>
 <li>Creates a <code>pkg</code> directory and move that JavaScript file and your WebAssembly code into it.</li>
 <li>Reads your <code>Cargo.toml</code> and produces an equivalent <code>package.json</code>.</li>
 <li>Copies your <code>README.md</code> (if you have one) into the package.</li>
</ol>

<p>The end result? You have an npm package inside of the <code>pkg</code> directory.</p>

<h4 id="A_digression_about_code_size">A digression about code size</h4>

<p>If you check out the generated WebAssembly code size, it may be a few hundred kilobytes. We haven't instructed Rust to optimize for size at all, and doing so cuts down on the size <em>a lot</em>. This is beyond the scope of this tutorial, but if you'd like to learn more, check out the Rust WebAssembly Working Group's documentation on <a href="https://rustwasm.github.io/book/game-of-life/code-size.html#shrinking-wasm-size">Shrinking .wasm Size</a>.</p>

<h3 id="Making_our_package_available_to_npm">Making our package available to npm</h3>

<p>Let's use `npm link` to make this package available to other javascript packages installed</p>

<pre class="brush: bash no-line-numbers notranslate">$ cd pkg
$ npm link</pre>

<p>We now have an npm package, written in Rust, but compiled to WebAssembly. It's ready for use from JavaScript, and doesn't require the user to have Rust installed; the code included was the WebAssembly code, not the Rust source.</p>

<h2 id="Using_the_package_on_the_web">Using the package on the web</h2>

<p>Let's build a website that uses our new package. Many people use npm packages through various bundler tools, and we'll be using one of them, <code>webpack</code>, in this tutorial. It's only a little bit complex, and shows a realistic use-case.</p>

<p>Let's move back out of the <code>pkg</code> directory, and make a new directory, <code>site</code>, to try this out in:</p>

<pre class="brush: bash no-line-numbers notranslate">$ cd ../..
$ mkdir site
$ cd site
$ npm link hello-wasm
</pre>

<p>Create a new file, <code>package.json</code>, and put the following code in it:</p>

<pre class="brush: json notranslate">{
  "scripts": {
    "serve": "webpack-dev-server"
  },
  "dependencies": {
    "hello-wasm": "^0.1.0"
  },
  "devDependencies": {
    "webpack": "^4.25.1",
    "webpack-cli": "^3.1.2",
    "webpack-dev-server": "^3.1.10"
  }
}</pre>

<p>Note that you need to fill in your own username, after the <code>@</code>, in the dependencies section.</p>

<p>Next, we need to configure Webpack. Create <code>webpack.config.js</code> and put the following in it:</p>

<pre class="brush: js notranslate">const path = require('path');
module.exports = {
  entry: "./index.js",
  output: {
    path: path.resolve(__dirname, "dist"),
    filename: "index.js",
  },
  mode: "development"
};</pre>

<p>Now we need an HTML file; create <code>index.html</code> and give it the following contents:</p>

<pre class="brush: html notranslate">&lt;!DOCTYPE html&gt;
&lt;html&gt;
  &lt;head&gt;
    &lt;meta charset="utf-8"&gt;
    &lt;title&gt;hello-wasm example&lt;/title&gt;
  &lt;/head&gt;
  &lt;body&gt;
    &lt;script src="./index.js"&gt;&lt;/script&gt;
  &lt;/body&gt;
&lt;/html&gt;</pre>

<p>Finally, create the <code>index.js</code> referenced in the HTML file and give it these contents:</p>

<pre class="brush: js notranslate">const js = import("./node_modules/hello-wasm/hello_wasm.js");
js.then(js =&gt; {
  js.greet("WebAssembly");
});</pre>

<p>Note that you need to fill in your npm username again.</p>

<p>This imports the new module from the <code>node_modules</code> folder. This isn't considered a best practice, but this is a demo, so it's OK for now. Once it's loaded, it calls the <code>greet</code> function from that module, passing <code>"WebAssembly"</code> as a string. Note how there's nothing special here, yet we're calling into Rust code. As far as the JavaScript code can tell, this is just a normal module.</p>

<p>We're done making files. Let's give this a shot:</p>

<pre class="brush: bash no-line-numbers notranslate">$ npm install
$ npm run serve</pre>

<p>This starts a web server. Load <a href="http://localhost:8080">http://localhost:8080</a> and an alert box appears on the screen, with <code>Hello, WebAssembly!</code> in it. We've successfully called from JavaScript into Rust, and from Rust into JavaScript.</p>

<h2 id="Conclusion">Conclusion</h2>

<p>This is the end of our tutorial; we hope you've found it useful.</p>

<p>There's lots of exciting work going on in this space; if you'd like to help make it even better, check out <a href="http://fitzgeraldnick.com/2018/02/27/wasm-domain-working-group.html">the Rust Webassembly Working Group</a>.</p>
